/* HMG Source Code

 Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 http://sites.google.com/site/hmgweb/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 HMG library code into it.

---------------------------------------------------------------------------*/

#include "hbclass.ch"
#include "common.ch"

*..............................................................................*
* Class ProgressBar ...........................................................*
*..............................................................................*

CLASS PROGRESSBAR FROM CONTROL

	* Internal Data

	DATA oQTObject		INIT	Nil
        DATA nValue             INIT    0
        DATA uValue             INIT    0
        DATA lInverted          INIT    .F.
	DATA lVisible           INIT    .T.
        DATA nRangeMin          INIT    0
        DATA nRangeMax          INIT    0
	DATA nAligment          INIT    1
        DATA nOrientation       INIT    1
  
	* Properties 
        METHOD RangeMin            SETGET
        METHOD RangeMax            SETGET
        METHOD Value               SETGET
	METHOD inverted            SETGET
	METHOD Textvisible         SETGET
	METHOD Aligment            SETGET
	METHOD Orientation         SETGET

	* Methods

	METHOD Create()

ENDCLASS



METHOD Orientation ( nOrientation ) CLASS PROGRESSBAR

	If Pcount() == 0
	
		RETURN ::oQTObject:Orientation()

	ElseIf Pcount() == 1 

		::oQTObject:setOrientation( nOrientation )

	EndIf

RETURN Nil


METHOD Aligment ( nAligment ) CLASS PROGRESSBAR

	If Pcount() == 0
	
		RETURN ::oQTObject:Alignment()

	ElseIf Pcount() == 1 

		::oQTObject:setAlignment( nAligment )

	EndIf

RETURN Nil



METHOD Textvisible ( lVisible ) CLASS PROGRESSBAR

	If Pcount() == 0
	
		RETURN ::oQTObject:TextVisible()

	ElseIf Pcount() == 1 

		::oQTObject:setTextVisible( lVisible )

	EndIf

RETURN Nil


METHOD Inverted ( lInverted ) CLASS PROGRESSBAR

	If Pcount() == 0
	
		RETURN ::oQTObject:InvertedAppearance()

	ElseIf Pcount() == 1 

		::oQTObject:setInvertedAppearance(lInverted)

	EndIf

RETURN Nil



METHOD Value ( uValue ) CLASS PROGRESSBAR

	If ::lCreated

	        If Pcount() == 0
	
			RETURN ::oQTObject:value()

		ElseIf Pcount() == 1 

			::oQTObject:setValue(uValue )

		EndIf


	EndIf

RETURN NIL


METHOD Rangemin ( nValue ) CLASS PROGRESSBAR

	If ::lCreated
		If Pcount() == 0
	
			RETURN ::oQTObject:minimum()

		ElseIf Pcount() == 1 
	
			::oQTObject:setminimum(nValue)

		EndIf
	Else

		If Pcount() == 0
   
			RETURN ::nRangeMin

		ElseIf Pcount() == 1

			::nRangeMin := nValue

		EndIf

	Endif

RETURN Nil


METHOD RangeMax ( nValue ) CLASS PROGRESSBAR

	If ::lCreated
		If Pcount() == 0
	
			RETURN ::oQTObject:maximum()

		ElseIf Pcount() == 1 

			::oQTObject:setmaximum(nValue)

		EndIf
	Else

		If Pcount() == 0
   
			RETURN ::nRangeMax

		ElseIf Pcount() == 1

			::nRangeMax := nValue

		EndIf

	Endif

RETURN Nil


*..............................................................................*
* Methods .....................................................................*
*..............................................................................*

METHOD Create() CLASS PROGRESSBAR

	::oQTObject := QProgressBar():New( ::oParent:oQTObject )
        ::oQTObject:SetRange( ::nRangeMin , ::nRangeMax )
	::oQTObject:Setvalue( 0 )
        ::oQTObject:Move( ::nCol(), ::nRow())
	if ValType(::nWidth) != 'U' .or. ValType(::nHeight) != 'U'
		if ValType(::nWidth) = 'U'
			::nWidth := 100
		endif
		
		if ValType(::nHeight) == 'U'
			::nHeight := 25
		endif

 		::oQTObject:resize( ::nWidth , ::nHeight )
	endif
	::oQTObject:show()
	::lCreated := .T.
	::oParent:AddData ( ::cName , Self )
RETURN Self
