
#xtranslate .<!msg!> => :<msg>

* Constants *******************************************************************

* Window Type

#define WND_STANDARD	0
#define WND_MAIN	1
#define WND_CHILD	2
#define WND_PANEL	3
#define WND_MODAL	4
#define WND_SPLITCHILD	5

* Button PictAlignment

#define BTN_TOP		0
#define BTN_BOTTOM	1
#define BTN_LEFT	2
#define BTN_RIGHT	3

* EditBox ScrollBars

#define EDB_NONE	0
#define EDB_VERTICAL	1
#define EDB_HORIZONTAL	2
#define EDB_BOTH	3

* Label Alignment

#define LBL_LEFT	0
#define LBL_CENTER	1
#define LBL_RIGHT	2

* TextBox Case Conversion

#define TXT_NONE	0
#define TXT_UPPER	1
#define TXT_LOWER	2

* TextBox DataType

#define TXT_CHARACTER	0
#define TXT_NUMERIC	1
#define TXT_DATE	2

* TextBox Alignment

#define TXT_LEFT	0
#define TXT_RIGHT	2

* ToolBar Button Styles

#define TBB_STANDARD		0
#define TBB_DROPDOWN		1
#define TBB_WHOLEDROPDOWN	2
#define TBB_CHECK		3
#define TBB_CHECKGROUP		4

* DatePicker Alignment

#define DTP_LEFT	0
#define DTP_RIGHT	2

*.............................................................................*
* xBase Syntax
*.............................................................................*

* Window **********************************************************************

#xcommand DEFINE WINDOW <oObj> ;
		[ <dummy1: OF , PARENT> <oParent> ] ;
		[ AT <nRow> , <nCol> ] ;
		[ ROW <nRow> ] ;
		[ COL <nCol> ] ;
		WIDTH <nWidth> ;
		HEIGHT <nHeight> ;
		[ VIRTUAL WIDTH <nVirtualWidth> ] ;                             
		[ VIRTUAL HEIGHT <nVirtualHeight> ] ;                             
		[ TITLE <cTitle> ] ;
		[ ICON <cIcon> ] ;
		[ <lMain:  MAIN> ] ;
		[ <lChild: CHILD> ] ;
		[ <lPanel: PANEL> ] ;
		[ CURSOR <cCursor> ] ;
		[ ON INIT <bOnInit> ] ;
		[ ON RELEASE <bOnRelease> ] ;
		[ ON INTERACTIVECLOSE <bOnInteractiveClose> ] ;
		[ ON MOUSECLICK <bOnMouseClick> ] ;
		[ ON MOUSEDRAG <bOnMouseDrag> ] ;
		[ ON MOUSEMOVE <bOnMouseMove> ] ;
		[ ON SIZE <bOnSize> ] ;
		[ ON MAXIMIZE <bOnMaximize> ] ;
		[ ON MINIMIZE <bOnMinimize> ] ;
		[ ON PAINT <bOnPaint> ] ;
	        [ BACKCOLOR <aBackColor> ] ;
		[ FONT <cFontName> SIZE <nFontSize> ] ;
		[ NOTIFYICON <cNotifyIcon> ] ;
		[ NOTIFYTOOLTIP <cNotifyToolTip> ] ;
		[ ON NOTIFYCLICK <bOnNotifyClick> ] ;
		[ ON GOTFOCUS <bOnGotFocus> ] ;
		[ ON LOSTFOCUS <bOnLostFocus> ] ;
		[ ON SCROLLUP <bOnScrollUp> ] ;
		[ ON SCROLLDOWN <bOnScrollDown> ] ;
		[ ON SCROLLLEFT <bOnScrollLeft> ] ;
		[ ON SCROLLRIGHT <bOnScrollRight> ] ;
		[ ON HSCROLLBOX <bOnHScrollBox> ] ;
		[ ON VSCROLLBOX <bOnVScrollBox> ] ;
		[ <lHelpButton:  HELPBUTTON> ] ;
		[ <lMain:  WINDOWTYPE MAIN> ] ;
		[ <lChild: WINDOWTYPE CHILD> ] ;
		[ WINDOWTYPE STANDARD ] ;
		[ VISIBLE <lVisible> ] ;
		[ AUTORELEASE <lAutoRelease> ] ;
		[ MINBUTTON <lMinButton> ] ;
		[ MAXBUTTON <lMaxButton> ] ;
		[ SIZABLE <lSizable> ] ;
		[ SYSMENU <lSysMenu> ] ;
		[ TITLEBAR <lTitleBar> ] ;
		[ FONTNAME <cFontName> FONTSIZE <nFontSize> ] ;
		[ <lNoVisible: NOSHOW> ] ;
		[ <lTopmost: TOPMOST> ] ;
		[ <lNoAutoRelease: NOAUTORELEASE> ] ;
		[ <lNoMinimize: NOMINIMIZE> ] ;
		[ <lNoMaximize: NOMAXIMIZE> ] ;
		[ <lNoSizable: NOSIZE> ] ;
		[ <lNoSysMenu: NOSYSMENU> ] ;                             
		[ <lNoTitleBar: NOCAPTION> ] ;                             
=>;
	__MVPUBLIC ( <"oObj"> )						;;
	With Object <oObj> := Window():New()				;;
		[:Parent			:= <oParent>		]	;;
		[:Row				:= <nRow>		]	;;
		[:Col				:= <nCol>		]	;;
		[:Width				:= <nWidth>		]	;;
		[:Height			:= <nHeight>		]	;;
		[:Title				:= <cTitle>		]	;; 
		[:FontName			:= <cFontName>		]	;;
		[:FontSize			:= <nFontSize>		]	;;
		[:BackColor			:= <aBackColor>		]	;; 
		[:TitleBar			:= <lTitleBar>		]	;; 
		[:SysMenu			:= <.lSysMenu.>		]	;; 
		[:Sizable			:= <.lSizable.>		]	;; 
		[:MinButton			:= <.lMinButton.>		]	;; 
		[:MaxButton			:= <.lMaxButton.>		]	;; 
		[:AutoRelease			:= <.lAutoRelease.>	]	;; 
		[:Visible			:= <.lVisible.>		]	;; 
		[:HelpButton			:= <.lHelpButton.>	]	;; 
		[:OnNotifyClick			:= <{bOnNotifyClick}>	]	;; 
		[:OnGotFocus			:= <{bOnGotFocus}>	]	;; 
		[:OnLostFocus			:= <{bOnLostFocus}>	]	;; 
		[:OnScrollUp			:= <{bOnScrollUp}>	]	;; 
		[:OnScrollDown			:= <{bOnScrollDown}>	]	;; 
		[:OnScrollLeft			:= <{bOnScrollLeft}>	]	;; 
		[:OnScrollRight			:= <{bOnScrollRight}>	]	;; 
		[:OnHScrollBox			:= <{bOnHScrollBox}>	]	;; 
		[:OnVScrollBox			:= <{bOnVScrollBox}>	]	;; 
		[:VirtualWidth			:= <nVirtualWidth>	]	;; 
		[:VirtualHeight			:= <nVirtualHeight>	]	;; 
		[:Icon				:= <cIcon>		]	;; 
		[:TopMost			:= <.lTopmost.>		]	;; 
		[:Cursor			:= <cCursor>		]	;; 
		[:OnInit			:= <{bOnInit}>		]	;; 
		[:OnRelease			:= <{bOnRelease}>		]	;; 
		[:OnInteractiveClose		:= <{bOnInteractiveClose}>]	;; 
		[:OnMouseDrag			:= <{bOnMouseDrag}>	]	;; 
		[:OnMouseClick			:= <{bOnMouseClick}>	]	;; 
		[:OnMouseMove			:= <{bOnMouseMove}>	]	;; 
		[:OnSize			:= <{bOnSize}>		]	;; 
		[:OnMaximize			:= <{bOnMaximize}>	]	;; 
		[:OnMinimize			:= <{bOnMinimize}>	]	;; 
		[:OnPaint			:= <{bOnPaint}>		]	;; 
		[:NotifyIcon			:= <cNotifyIcon>	]	;; 
		[:NotifyToolTip			:= <cNotifyToolTip>	]	;; 
		[:Visible			:= !<.lNoVisible.>	]	;; 
		[:AutoRelease			:= !<.lNoAutoRelease.>	]	;; 
		[:Minimize			:= !<.lNoMinimize.>	]	;; 
		[:Maximize			:= !<.lNoMaximize.>	]	;;
		[:Sizable			:= !<.lNoSizable.>	]	;; 
		[:SysMenu			:= !<.lNoSysMenu.>	]	;; 
		[:TitleBar			:= !<.lNoTitleBar.>	]	;;
		[:Type				:= If ( <.lMain.> , WND_MAIN , if ( <.lChild.> , WND_CHILD , if ( <.lPanel.> , WND_PANEL , WND_STANDARD ) ) ) ] 


#xcommand DEFINE WINDOW <oObj> ;
		[ <dummy1: OF , PARENT> <oParent> ] ;
		[ AT <nRow> , <nCol> ] ;
		[ ROW <nRow> ] ;
		[ COL <nCol> ] ;
		WIDTH <nWidth> ;
		HEIGHT <nHeight> ;
		[ VIRTUAL WIDTH <nVirtualWidth> ] ;                             
		[ VIRTUAL HEIGHT <nVirtualHeight> ] ;                             
		[ TITLE <cTitle> ] ;
		[ ICON <cIcon> ] ;
		WINDOWTYPE ;
		[ <lMain:  MAIN> ] ;
		[ <lChild: CHILD> ] ;
		[ <lPanel: PANEL> ] ;
		[ CURSOR <cCursor> ] ;
		[ ON INIT <bOnInit> ] ;
		[ ON RELEASE <bOnRelease> ] ;
		[ ON INTERACTIVECLOSE <bOnInteractiveClose> ] ;
		[ ON MOUSECLICK <bOnMouseClick> ] ;
		[ ON MOUSEDRAG <bOnMouseDrag> ] ;
		[ ON MOUSEMOVE <bOnMouseMove> ] ;
		[ ON SIZE <bOnSize> ] ;
		[ ON MAXIMIZE <bOnMaximize> ] ;
		[ ON MINIMIZE <bOnMinimize> ] ;
		[ ON PAINT <bOnPaint> ] ;
	        [ BACKCOLOR <aBackColor> ] ;
		[ FONT <cFontName> SIZE <nFontSize> ] ;
		[ NOTIFYICON <cNotifyIcon> ] ;
		[ NOTIFYTOOLTIP <cNotifyToolTip> ] ;
		[ ON NOTIFYCLICK <bOnNotifyClick> ] ;
		[ ON GOTFOCUS <bOnGotFocus> ] ;
		[ ON LOSTFOCUS <bOnLostFocus> ] ;
		[ ON SCROLLUP <bOnScrollUp> ] ;
		[ ON SCROLLDOWN <bOnScrollDown> ] ;
		[ ON SCROLLLEFT <bOnScrollLeft> ] ;
		[ ON SCROLLRIGHT <bOnScrollRight> ] ;
		[ ON HSCROLLBOX <bOnHScrollBox> ] ;
		[ ON VSCROLLBOX <bOnVScrollBox> ] ;
		[ HELPBUTTON <lHelpButton> ] ;
		[ <lMain:  WINDOWTYPE MAIN> ] ;
		[ <lChild: WINDOWTYPE CHILD> ] ;
		[ WINDOWTYPE STANDARD ] ;
		[ VISIBLE <lVisible> ] ;
		[ AUTORELEASE <lAutoRelease> ] ;
		[ MINBUTTON <lMinButton> ] ;
		[ MAXBUTTON <lMaxButton> ] ;
		[ SIZABLE <lSizable> ] ;
		[ SYSMENU <lSysMenu> ] ;
		[ TITLEBAR <lTitleBar> ] ;
		[ FONTNAME <cFontName> FONTSIZE <nFontSize> ] ;
		[ <lNoVisible: NOSHOW> ] ;
		[ TOPMOST <lTopmost> ] ;
		[ <lNoAutoRelease: NOAUTORELEASE> ] ;
		[ <lNoMinimize: NOMINIMIZE> ] ;
		[ <lNoMaximize: NOMAXIMIZE> ] ;
		[ <lNoSizable: NOSIZE> ] ;
		[ <lNoSysMenu: NOSYSMENU> ] ;                             
		[ <lNoTitleBar: NOCAPTION> ] ;                             
=>;
	__MVPUBLIC ( <"oObj"> )						;;
	With Object <oObj> := Window():New()				;;
		[:Parent		:= <oParent>		]	;;
		[:Row			:= <nRow>		]	;;
		[:Col			:= <nCol>		]	;;
		[:Width			:= <nWidth>		]	;;
		[:Height		:= <nHeight>		]	;;
		[:Title			:= <cTitle>		]	;; 
		[:FontName		:= <cFontName>		]	;;
		[:FontSize		:= <nFontSize>		]	;;
		[:BackColor		:= <aBackColor>		]	;; 
		[:TitleBar		:= <.lTitleBar.>		]	;; 
		[:SysMenu		:= <.lSysMenu.>		]	;; 
		[:Sizable		:= <.lSizable.>		]	;; 
		[:MinButton		:= <.lMinButton.>		]	;; 
		[:MaxButton		:= <.lMaxButton.>		]	;; 
		[:AutoRelease		:= <.lAutoRelease.>	]	;; 
		[:Visible		:= <.lVisible.>		]	;; 
		[:HelpButton		:= <.lHelpButton.>	]	;; 
		[:OnNotifyClick		:= <{bOnNotifyClick}>	]	;; 
		[:OnGotFocus		:= <{bOnGotFocus}>	]	;; 
		[:OnLostFocus		:= <{bOnLostFocus}>	]	;; 
		[:OnScrollUp		:= <{bOnScrollUp}>	]	;; 
		[:OnScrollDown		:= <{bOnScrollDown}>	]	;; 
		[:OnScrollLeft		:= <{bOnScrollLeft}>	]	;; 
		[:OnScrollRight		:= <{bOnScrollRight}>	]	;; 
		[:OnHScrollBox		:= <{bOnHScrollBox}>	]	;; 
		[:OnVScrollBox		:= <{bOnVScrollBox}>	]	;; 
		[:VirtualWidth		:= <nVirtualWidth>	]	;; 
		[:VirtualHeight		:= <nVirtualHeight>	]	;; 
		[:Icon			:= <cIcon>		]	;; 
		[:TopMost		:= <.lTopmost.>		]	;; 
		[:Cursor		:= <cCursor>		]	;; 
		[:OnInit		:= <{bOnInit}>		]	;; 
		[:OnRelease		:= <{bOnRelease}>		]	;; 
		[:OnInteractiveClose	:= <{bOnInteractiveClose}>]	;; 
		[:OnMouseDrag		:= <{bOnMouseDrag}>	]	;; 
		[:OnMouseClick		:= <{bOnMouseClick}>	]	;; 
		[:OnMouseMove		:= <{bOnMouseMove}>	]	;; 
		[:OnSize		:= <{bOnSize}>		]	;; 
		[:OnMaximize		:= <{bOnMaximize}>	]	;; 
		[:OnMinimize		:= <{bOnMinimize}>	]	;; 
		[:OnPaint		:= <{bOnPaint}>		]	;; 
		[:NotifyIcon		:= <cNotifyIcon>	]	;; 
		[:NotifyToolTip		:= <cNotifyToolTip>	]	;; 
		[:Visible		:= !<.lNoVisible.>	]	;; 
		[:AutoRelease		:= !<.lNoAutoRelease.>	]	;; 
		[:Minimize		:= !<.lNoMinimize.>	]	;; 
		[:Maximize		:= !<.lNoMaximize.>	]	;;
		[:Sizable		:= !<.lNoSizable.>	]	;; 
		[:SysMenu		:= !<.lNoSysMenu.>	]	;; 
		[:TitleBar		:= !<.lNoTitleBar.>	]	;;
		[:Type			:= If ( <.lMain.> , WND_MAIN , if ( <.lChild.> , WND_CHILD , if ( <.lPanel.> , WND_PANEL , WND_STANDARD ) ) ) ] 


	#xcommand DEFINE WINDOW <oObj> ;
			[ AT <nRow>,<nCol> ] ;
			[ ROW <nRow> ] ;
			[ COL <nCol> ] ;
			WIDTH <nWidth> ;
			HEIGHT <nHeight> ;
			[ VIRTUAL WIDTH <nVirtualWidth> ] ;                             
			[ VIRTUAL HEIGHT <nVirtualHeight> ] ;                             
			[ TITLE <cTitle> ] ;
			[ ICON <cIcon> ] ;
			MODAL ;
			[ <lNoVisible: NOSHOW> ] ;
			[ <lNoAutoRelease: NOAUTORELEASE> ] ;
			[ <lNoSizable: NOSIZE> ] ;
			[ <lNoSysMenu: NOSYSMENU> ] ;                             
			[ <lNoTitleBar: NOCAPTION> ] ;                             
			[ CURSOR <cCursor> ] ;
			[ ON INIT <bOnInit> ] ;
			[ ON RELEASE <bOnRelease> ] ;
			[ ON INTERACTIVECLOSE <bOnInteractiveClose> ] ;
			[ ON MOUSECLICK <bOnMouseClick> ] ;
			[ ON MOUSEDRAG <bOnMouseDrag> ] ;
			[ ON MOUSEMOVE <bOnMouseMove> ] ;
			[ ON SIZE <bOnSize> ] ;
			[ ON PAINT <bOnPaint> ] ;
		        [ BACKCOLOR <aBackColor> ] ;
			[ FONT <cFontName> SIZE <nFontSize> ] ;
			[ ON GOTFOCUS <bOnGotFocus> ] ;
			[ ON LOSTFOCUS <bOnLostFocus> ] ;
			[ ON SCROLLUP <bOnScrollUp> ] ;
			[ ON SCROLLDOWN <bOnScrollDown> ] ;
			[ ON SCROLLLEFT <bOnScrollLeft> ] ;
			[ ON SCROLLRIGHT <bOnScrollRight> ] ;
			[ ON HSCROLLBOX <bOnHScrollBox> ] ;
			[ ON VSCROLLBOX <bOnVScrollBox> ] ;
			[ <lHelpButton:  HELPBUTTON> ] ;
			[ VISIBLE <lVisible> ] ;
			[ AUTORELEASE <lAutoRelease> ] ;
			[ SIZABLE <lSizable> ] ;
			[ SYSMENU <lSysMenu> ] ;
			[ TITLEBAR <lTitleBar> ] ;
			[ FONTNAME <cFontName> FONTSIZE <nFontSize> ] ;
=>;
	__MVPUBLIC ( <"oObj"> )						;;
	With Object <oObj> := Window():New()				;;
		:Type				:= WND_MODAL 			;;
		[:Row				:= <nRow>		]	;;
		[:Col				:= <nCol>		]	;;
		[:Width				:= <nWidth>		]	;;
		[:Height			:= <nHeight>		]	;;
		[:Title				:= <cTitle>		]	;; 
		[:FontName			:= <cFontName>		]	;;
		[:FontSize			:= <nFontSize>		]	;;
		[:BackColor			:= <aBackColor>		]	;; 
		[:TitleBar			:= <.lTitleBar.>	]	;; 
		[:SysMenu			:= <.lSysMenu.>		]	;; 
		[:Sizable			:= <.lSizable.>		]	;; 
		[:AutoRelease			:= <.lAutoRelease.>	]	;; 
		[:Visible			:= <.lVisible.>		]	;; 
		[:HelpButton			:= <.lHelpButton.>	]	;; 
		[:OnGotFocus			:= <{bOnGotFocus}>	]	;; 
		[:OnLostFocus			:= <{bOnLostFocus}>	]	;; 
		[:OnScrollUp			:= <{bOnScrollUp}>	]	;; 
		[:OnScrollDown			:= <{bOnScrollDown}>	]	;; 
		[:OnScrollLeft			:= <{bOnScrollLeft}>	]	;; 
		[:OnScrollRight			:= <{bOnScrollRight}>	]	;; 
		[:OnHScrollBox			:= <{bOnHScrollBox}>	]	;; 
		[:OnVScrollBox			:= <{bOnVScrollBox}>	]	;; 
		[:VirtualWidth			:= <nVirtualWidth>	]	;; 
		[:VirtualHeight			:= <nVirtualHeight>	]	;; 
		[:Icon				:= <cIcon>		]	;; 
		[:Cursor			:= <cCursor>		]	;; 
		[:OnInit			:= <{bOnInit}>		]	;; 
		[:OnRelease			:= <{bOnRelease}>		]	;; 
		[:OnInteractiveClose		:= <{bOnInteractiveClose}>]	;; 
		[:OnMouseDrag			:= <{bOnMouseDrag}>	]	;; 
		[:OnMouseClick			:= <{bOnMouseClick}>	]	;; 
		[:OnMouseMove			:= <{bOnMouseMove}>	]	;; 
		[:OnSize			:= <{bOnSize}>		]	;; 
		[:OnPaint			:= <{bOnPaint}>		]	;; 
		[:Visible			:= !<.lNoVisible.>	]	;; 
		[:AutoRelease			:= !<.lNoAutoRelease.>	]	;; 
		[:Sizable			:= !<.lNoSizable.>	]	;; 
		[:SysMenu			:= !<.lNoSysMenu.>	]	;; 
		[:TitleBar			:= !<.lNoTitleBar.>	]	


	#xcommand DEFINE WINDOW <oObj> ;
			[ AT <nRow>,<nCol> ] ;
			[ ROW <nRow> ] ;
			[ COL <nCol> ] ;
			WIDTH <nWidth> ;
			HEIGHT <nHeight> ;
			[ VIRTUALWIDTH <nVirtualWidth> ] ;                             
			[ VIRTUALHEIGHT <nVirtualHeight> ] ;                             
			[ TITLE <cTitle> ] ;
			[ ICON <cIcon> ] ;
			WINDOWTYPE MODAL ;
			[ <lNoVisible: NOSHOW> ] ;
			[ <lNoAutoRelease: NOAUTORELEASE> ] ;
			[ <lNoSizable: NOSIZE> ] ;
			[ <lNoSysMenu: NOSYSMENU> ] ;                             
			[ <lNoTitleBar: NOCAPTION> ] ;                             
			[ CURSOR <cCursor> ] ;
			[ ONINIT <bOnInit> ] ;
			[ ONRELEASE <bOnRelease> ] ;
			[ ONINTERACTIVECLOSE <bOnInteractiveClose> ] ;
			[ ONMOUSECLICK <bOnMouseClick> ] ;
			[ ONMOUSEDRAG <bOnMouseDrag> ] ;
			[ ONMOUSEMOVE <bOnMouseMove> ] ;
			[ ONSIZE <bOnSize> ] ;
			[ ONPAINT <bOnPaint> ] ;
		        [ BACKCOLOR <aBackColor> ] ;
			[ FONT <cFontName> SIZE <nFontSize> ] ;
			[ ONGOTFOCUS <bOnGotFocus> ] ;
			[ ONLOSTFOCUS <bOnLostFocus> ] ;
			[ ONSCROLLUP <bOnScrollUp> ] ;
			[ ONSCROLLDOWN <bOnScrollDown> ] ;
			[ ONSCROLLLEFT <bOnScrollLeft> ] ;
			[ ONSCROLLRIGHT <bOnScrollRight> ] ;
			[ ONHSCROLLBOX <bOnHScrollBox> ] ;
			[ ONVSCROLLBOX <bOnVScrollBox> ] ;
			[ HELPBUTTON <lHelpButton> ] ;
			[ VISIBLE <lVisible> ] ;
			[ AUTORELEASE <lAutoRelease> ] ;
			[ SIZABLE <lSizable> ] ;
			[ SYSMENU <lSysMenu> ] ;
			[ TITLEBAR <lTitleBar> ] ;
			[ FONTNAME <cFontName> FONTSIZE <nFontSize> ] ;
=>;
	__MVPUBLIC ( <"oObj"> )						;;
	With Object <oObj> := Window():New()				;;
		:Type				:= WND_MODAL 			;;
		[:Row				:= <nRow>		]	;;
		[:Col				:= <nCol>		]	;;
		[:Width				:= <nWidth>		]	;;
		[:Height			:= <nHeight>		]	;;
		[:Title				:= <cTitle>		]	;; 
		[:FontName			:= <cFontName>		]	;;
		[:FontSize			:= <nFontSize>		]	;;
		[:BackColor			:= <aBackColor>		]	;; 
		[:TitleBar			:= <.lTitleBar.>	]	;; 
		[:SysMenu			:= <.lSysMenu.>		]	;; 
		[:Sizable			:= <.lSizable.>		]	;; 
		[:AutoRelease			:= <.lAutoRelease.>	]	;; 
		[:Visible			:= <.lVisible.>		]	;; 
		[:HelpButton			:= <.lHelpButton.>	]	;; 
		[:OnGotFocus			:= <{bOnGotFocus}>	]	;; 
		[:OnLostFocus			:= <{bOnLostFocus}>	]	;; 
		[:OnScrollUp			:= <{bOnScrollUp}>	]	;; 
		[:OnScrollDown			:= <{bOnScrollDown}>	]	;; 
		[:OnScrollLeft			:= <{bOnScrollLeft}>	]	;; 
		[:OnScrollRight			:= <{bOnScrollRight}>	]	;; 
		[:OnHScrollBox			:= <{bOnHScrollBox}>	]	;; 
		[:OnVScrollBox			:= <{bOnVScrollBox}>	]	;; 
		[:VirtualWidth			:= <nVirtualWidth>	]	;; 
		[:VirtualHeight			:= <nVirtualHeight>	]	;; 
		[:Icon				:= <cIcon>		]	;; 
		[:Cursor			:= <cCursor>		]	;; 
		[:OnInit			:= <{bOnInit}>		]	;; 
		[:OnRelease			:= <{bOnRelease}>		]	;; 
		[:OnInteractiveClose		:= <{bOnInteractiveClose}>]	;; 
		[:OnMouseDrag			:= <{bOnMouseDrag}>	]	;; 
		[:OnMouseClick			:= <{bOnMouseClick}>	]	;; 
		[:OnMouseMove			:= <{bOnMouseMove}>	]	;; 
		[:OnSize			:= <{bOnSize}>		]	;; 
		[:OnPaint			:= <{bOnPaint}>		]	;; 
		[:Visible			:= !<.lNoVisible.>	]	;; 
		[:AutoRelease			:= !<.lNoAutoRelease.>	]	;; 
		[:Sizable			:= !<.lNoSizable.>	]	;; 
		[:SysMenu			:= !<.lNoSysMenu.>	]	;; 
		[:TitleBar			:= !<.lNoTitleBar.>	]	


#xcommand END WINDOW => :EndWindow() ; End With

#xcommand ACTIVATE WINDOW <oObj> => <oObj>:Activate()

* Frame ***********************************************************************

#xcommand @ <nRow> , <nCol> FRAME <oObj> ;
		[ <dummy1: OF, PARENT> <oParent> ] ;
		[ CAPTION <cCaption> ] ;
		[ WIDTH <nWidth> ] ;
		[ HEIGHT <nHeight> ] ;
		[ FONT <cFontName> ] ;
		[ SIZE <nFontSize> ] ;
		[ <lFontBold : BOLD> ] ;
		[ <lFontItalic : ITALIC> ] ;
		[ <lFontUnderline : UNDERLINE> ] ;
		[ <lFontStrikeout : STRIKEOUT> ] ;
		[ BACKCOLOR <aBackColor> ] ;
		[ FONTCOLOR <aFontColor> ] ;
		[ <lTransparent: TRANSPARENT> ] ;
	=>;
	With Object <oObj> := Frame():New() ; :Name := <"oObj"> ;;
		[:Parent	:= <oParent>		]	;;
		[:Caption	:= <cCaption>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;;
		[:lTransparent	:= <.lTransparent.>	]	;;
	End <oObj>


* Button **********************************************************************

#xcommand @ <nRow> , <nCol> BUTTON <oObj> ;
		[ <dummy1: OF, PARENT> <oParent> ] ;
		[ CAPTION <cCaption> ] ;
		[ <dummy2: ACTION,ON CLICK,ONCLICK> <bOnClick> ];
		[ WIDTH <nWidth> ] ;
		[ HEIGHT <nHeight> ] ;
		[ FONT <cFontName> ] ;
		[ SIZE <nFontSize> ] ;
		[ <lFontBold : BOLD> ] ;
		[ <lFontItalic : ITALIC> ] ;
		[ <lFontUnderline : UNDERLINE> ] ;
		[ <lFontStrikeout : STRIKEOUT> ] ;
		[ BACKCOLOR <aBackColor> ] ;
		[ FONTCOLOR <aFontColor> ] ;
		[ <lTransparent: TRANSPARENT> ] ;
		[ TOOLTIP <cToolTip> ] ;
		[ <lFlat: FLAT> ] ;
		[ ON GOTFOCUS <bOnGotFocus> ] ;
		[ ON LOSTFOCUS <bOnLostFocus> ] ;
		[ <lTabStop: NOTABSTOP> ] ;
		[ HELPID <nHelpId> ] 		;
		[ <lNoVisible: INVISIBLE> ] ;
		[ <lMultiLine: MULTILINE> ] ;
		[ PICTURE <cPicture> ] ;
		[ <cAlignment:LEFT,RIGHT,TOP,BOTTOM> ] ;
	=>;
	With Object <oObj> := Button():New() ; :Name := <"oObj"> ;;
		[:Parent	:= <oParent>		]	;;
		[:Caption	:= <cCaption>		]	;;
		[:OnClick	:= <{bOnClick}>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;;
		[:Transparent	:= <.lTransparent.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:Flat		:= <.lFlat.>		]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:TabStop	:= !<.lTabStop.>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:Multiline	:= <.lMultiLine.>	]	;;
		[:Picture	:= <cPicture>		]	;;
		[:PictAlignment	:= If ( Upper(<"cAlignment">) == 'TOP', BTN_TOP , If( Upper(<"cAlignment">) == 'BOTTOM' , BTN_BOTTOM , If( Upper(<"cAlignment">) == 'LEFT' , BTN_LEFT , BTN_RIGHT ) ) ) ] ;;
	End <oObj>

* Label **********************************************************************

#command @ <nRow>,<nCol> LABEL <oObj>   ;
	[ <dummy1: OF, PARENT> <oParent> ] ;
	[ VALUE <cValue> ]   ;
	[ ACTION <bOnClick> ] ;
	[ WIDTH <nWidth> ]   ;
	[ HEIGHT <nHeight> ]   ;
	[ <lAutoSize : AUTOSIZE> ] ;
	[ FONT <cFontName> ]   ;
	[ SIZE <nFontSize> ]   ;
	[ <lFontBold : BOLD> ] ;
	[ <lFontItalic : ITALIC> ] ;
	[ <lFontUnderline : UNDERLINE> ] ;
	[ <lFontStrikeout : STRIKEOUT> ] ;
	[ TOOLTIP <cToolTip> ] ;
	[ BACKCOLOR <aBackColor> ] ;
	[ FONTCOLOR <aFontColor> ] ;
	[ <lTransparent: TRANSPARENT> ] ;
	[ <lRightAlign: RIGHTALIGN> ]	;
	[ <lCenterAlign: CENTERALIGN> ]	;
	[ HELPID <nHelpId> ] 		;
	[ <lNoVisible: INVISIBLE> ] ;
	=>;
	With Object <oObj> := Label():New() ; :Name := <"oObj"> ;;
		[:Parent	:= <oParent>		]	;;
		[:Value		:= <cValue>		]	;;
		[:OnClick	:= <bOnClick>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:AutoSize	:= <.lAutoSize.>	]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;;
		[:Transparent	:= <.lTransparent.>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:Alignment	:= If ( <.lRightAlign.> , LBL_RIGHT , If( <.lCenterAlign.> , LBL_CENTER , LBL_LEFT ) ) ] ;;
	End <oObj>

* CheckBox ********************************************************************

#xcommand @ <nRow>,<nCol> CHECKBOX <oObj>			;
		[ <dummy1: OF, PARENT> <oParent> ]		;
		[ CAPTION <cCaption>	]			;
		[ WIDTH <nWidth> ]				;
		[ HEIGHT <nHeight> ]				;
		[ FIELD <cField> ]				;
		[ VALUE <lValue> ]				;
		[ FONT <cFontName> ]				;
		[ SIZE <nFontSize> ]				;
		[ <lFontBold : BOLD> ]				;
		[ <lFontItalic : ITALIC> ]			;
		[ <lFontUnderline : UNDERLINE> ]		;
		[ <lFontStrikeout : STRIKEOUT> ]		;
		[ TOOLTIP <cToolTip> ]				;
		[ BACKCOLOR <aBackColor> ]			;
		[ FONTCOLOR <aFontColor> ]			;
		[ ON GOTFOCUS <bOnGotFocus> ]			;
		[ ON CHANGE <bOnChange> ]			;
		[ ON LOSTFOCUS <bOnLostFocus> ]			;
		[ <lTransparent: TRANSPARENT> ]			;
		[ HELPID <nHelpId> ]				;
		[ <lNoVisible: INVISIBLE> ]			;
		[ <lNoTabStop: NOTABSTOP> ]			;
	=>;
	With Object <oObj> := CheckBox():New() ; :Name := <"oObj"> ;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Caption	:= <cCaption>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Value		:= <lValue>		]	;;
		[:OnChange	:= <{bOnChange}>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Field		:= <"cField">		]	;;	
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:Transparent	:= <.lTransparent.>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;;
	End <oObj>


* TextBox ********************************************************************

// Standard

#command @ <nRow>, <nCol> TEXTBOX <oObj>               			;
			[ <dummy1: OF, PARENT> <oParent> ]		;
                        [ HEIGHT <nHeight> ]          			;
                        [ WIDTH <nWidth> ]            			;
			[ FIELD <cField> ]				;
                        [ VALUE <cValue> ]            			;
			[ < lReadOnly: READONLY > ] 			;
                        [ FONT <cFontName> ]          			;
                        [ SIZE <nFontSize> ]          			;
			[ <lFontBold : BOLD> ]				;
			[ <lFontItalic : ITALIC> ]			;
			[ <lFontUnderline : UNDERLINE> ]		;
			[ <lFontStrikeout : STRIKEOUT> ]		;
                        [ TOOLTIP <cToolTip> ]        			;
			[ BACKCOLOR <aBackColor> ]			;
			[ FONTCOLOR <aFontColor> ]			;
			[ DISABLEDBACKCOLOR <aDisabledBackColor> ]	;
			[ DISABLEDFONTCOLOR <aDisabledFontColor> ]	;
                        [ MAXLENGTH <nMaxLenght> ]			;
                        [ <lUpper: UPPERCASE> ]				;
                        [ <lLower: LOWERCASE> ]				;
                        [ <lNumeric: NUMERIC> ]				;
                        [ <lPassWord: PASSWORD> ]			;
                        [ ON CHANGE <bOnChange> ]			;
                        [ ON GOTFOCUS <bOnGotFocus> ]			;
                        [ ON LOSTFOCUS <bOnLostFocus> ]			;
                        [ ON ENTER <bOnEnter> ]		;
                        [ <lRightAlign: RIGHTALIGN> ]	;
			[ <lNoVisible: INVISIBLE> ]	;
			[ <lNoTabStop: NOTABSTOP> ]	;
                        [ HELPID <nHelpId> ] 		;
	=>;
	With Object <oObj> := TextBox():New() ; :Name := <"oObj"> ;;
		[:Parent	:= <oParent>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Field		:= <"cField">		]	;;	
		[:Value		:= <cValue>		]	;;
		[:lReadOnly	:= <.lReadOnly.>	]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;;
		[:MaxLenght	:= <nMaxLenght>		]	;;
		[:PassWord	:= <.lPassWord.>	]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:OnEnter	:= <{bOnEnter}>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:Alignment		:= if( <.lRightAlign.> , 2 , 0 ) ]			;;
		[:DisabledBackColor	:= <aDisabledBackColor>	]				;; 
		[:DisabledFontColor	:= <aDisabledFontColor>	]				;;
		[:CaseConvert		:= if ( <.lUpper.> , 1 , If( <.lLower.> , 2 , 0  )  ) ]	;;
		[:DataType		:= if ( <.lNumeric.> , 1 , 0 ) ]			;;
	End <oObj>

#command @ <nRow>,<nCol> TEXTBOX <oObj>		;
		[ <dummy1: OF, PARENT> <oParent> ] ;
                [ HEIGHT <nHeight> ]		;
		[ WIDTH <nWidth> ]			;
		[ FIELD <cField> ]		;
		[ VALUE <nValue> ]		;
		[ < lReadOnly: READONLY > ] 	;
		[ FONT <cFontName> ]		;
		[ SIZE <nFontSize> ]		;
		[ <lFontBold : BOLD> ] ;
		[ <lFontItalic : ITALIC> ] ;
		[ <lFontUnderline : UNDERLINE> ] ;
		[ <lFontStrikeout : STRIKEOUT> ] ;
		[ TOOLTIP <cToolTip> ]		;
		[ BACKCOLOR <aBackColor> ] ;
		[ FONTCOLOR <aFontColor> ] ;
		[ DISABLEDBACKCOLOR <aDisabledBackColor> ] ;
		[ DISABLEDFONTCOLOR <aDisabledFontColor> ] ;
		NUMERIC				;
		INPUTMASK <cInputMask>		;
                [ FORMAT <cFormat> ]		;
                [ ON CHANGE <bOnChange> ]		;
		[ ON GOTFOCUS <bOnGotFocus> ]	;
		[ ON LOSTFOCUS <bOnLostFocus> ]	;
                [ ON ENTER <bOnEnter> ]		;
                [ <lRightAlign: RIGHTALIGN> ]    ;
		[ <lNoVisible: INVISIBLE> ]	;
		[ <lNoTabStop: NOTABSTOP> ]	;
		[ HELPID <nHelpId> ] 		;
	=>;
	With Object <oObj> := TextBox():New() ; :Name := <"oObj"> ;;
		[:Parent	:= <oParent>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Field		:= <"cField">		]	;;	
		[:Value		:= <nValue>		]	;;
		[:ReadOnly	:= <.lReadOnly.>	]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;; 
		[:OnChange	:= <{bOnChange}>		]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:OnEnter	:= <bOnEnter>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:DataType	:= 1 			]	;;
		[:InputMask	:= <cInputMask>		]	;;
		[:Format	:= <cFormat>		]	;;
		[:Alignment		:= if( <.lRightAlign.> , 2 , 0 ) 			]	;;
		[:DisabledBackColor	:= <aDisabledBackColor>					]	;; 
		[:DisabledFontColor	:= <aDisabledFontColor>					]	;;
	End <oObj>


* EditBox *********************************************************************

#command @ <nRow>, <nCol> EDITBOX <oObj>               			;
			[ <dummy1: OF, PARENT> <oParent> ]		;
                        [ HEIGHT <nHeight> ]          			;
                        [ WIDTH <nWidth> ]            			;
			[ FIELD <cField> ]				;
                        [ VALUE <cValue> ]            			;
			[ <lReadOnly: READONLY> ] 			;
                        [ FONT <cFontName> ]          			;
                        [ SIZE <nFontSize> ]          			;
			[ <lFontBold : BOLD> ]				;
			[ <lFontItalic : ITALIC> ]			;
			[ <lFontUnderline : UNDERLINE> ]		;
			[ <lFontStrikeout : STRIKEOUT> ]		;
                        [ TOOLTIP <cToolTip> ]        			;
			[ BACKCOLOR <aBackColor> ]			;
			[ FONTCOLOR <aFontColor> ]			;
			[ DISABLEDBACKCOLOR <aDisabledBackColor> ]	;
			[ DISABLEDFONTCOLOR <aDisabledFontColor> ]	;
                        [ MAXLENGTH <nMaxLenght> ]			;
                        [ ON CHANGE <bOnChange> ]			;
                        [ ON GOTFOCUS <bOnGotFocus> ]			;
                        [ ON LOSTFOCUS <bOnLostFocus> ]			;
			[ <lNoVisible: INVISIBLE> ]	;
			[ <lNoTabStop: NOTABSTOP> ]	;
			[ <lNoVScroll: NOVSCROLL> ]   ;
			[ <lNoHScroll: NOHSCROLL> ]   ;
                        [ HELPID <nHelpId> ] 		;
	=>;
	With Object <oObj> := EditBox():New() ; :Name := <"oObj"> ;;
		[:Parent	:= <oParent>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Field		:= <"cField">		]	;;	
		[:Value		:= <cValue>		]	;;
		[:lReadOnly	:= <.lReadOnly.>	]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;;
		[:MaxLenght	:= <nMaxLenght>		]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:DisabledBackColor	:= <aDisabledBackColor>	]				;; 
		[:DisabledFontColor	:= <aDisabledFontColor>	]				;;
		[:ScrollBars		:= if ( !<.lNoVScroll.>	.and. !<.lNoHScroll.> , EDB_NONE , if( <.lNoVScroll.> .and. !<.lNoHScroll.> , EDB_HORIZONTAL , if( !<.lNoVScroll.> .and. <.lNoHScroll.> , EDB_VERTICAL , EDB_BOTH ) ) ) ]	;;
	End <oObj>


* Spinner *********************************************************************

#command @ <nRow>,<nCol> SPINNER <oObj> ;
		[ <dummy1: OF, PARENT> <oParent> ] ;
		RANGE <nRangeMin> , <nRangeMax> ;
		[ VALUE <nValue> ] ;
		[ WIDTH <nWidth> ] ;
		[ HEIGHT <nHeight> ] ;
		[ FONT <cFontName> ] ;
		[ SIZE <nFontSize> ] ;
		[ <lFontBold : BOLD> ] ;
		[ <lFontItalic : ITALIC> ] ;
		[ <lFontUnderLine : UNDERLINE> ] ;
		[ <lFontStrikeout : STRIKEOUT> ] ;
		[ TOOLTIP <cToolTip> ] ;
		[ BACKCOLOR <aBackColor> ] ;
		[ FONTCOLOR <aFontColor> ] ;
		[ ON GOTFOCUS <bOnGotFocus> ] ;
		[ ON CHANGE <bOnChange> ] ;
		[ ON LOSTFOCUS <bOnLostFocus> ] ;
		[ HELPID <nHelpId> ] 		;
		[ <lNoVisible : INVISIBLE> ] ;
		[ <lNoTabStop : NOTABSTOP> ] ;
		[ <lWrap : WRAP> ] ;
		[ <lReadOnly : READONLY> ] ;
		[ INCREMENT <nIncrement> ] ;
	=>;
	With Object <oObj> := Spinner():New() ; :Name := <"oObj"> ;;
		[:RangeMin	:= <nRangeMin>		]	;;
		[:RangeMax	:= <nRangeMax>		]	;;
		[:Value		:= <nValue>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderLine.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;;
		[:Wrap      := <.lWrap.> ]          ;;
		[:Increment	:= <nIncrement>		]	;;
	End <oObj>

* Grid ************************************************************************

#command @ <nRow>,<nCol> GRID <oObj> 			;
		[ <dummy1: OF, PARENT> <oParent> ]	;
		[ WIDTH <nWidth> ] 			;
		[ HEIGHT <nHeight> ] 			;
		[ HEADERS <aColumnHeaders> ] 		;
		[ WIDTHS <aColumnWidths> ] 		;
		[ ITEMS <aItems> ] 			;
		[ VALUE <xValue> ] 			;
		[ FONT <cFontName> ] 			;
		[ SIZE <nFontSize> ] 			;
		[ <lFontBold : BOLD> ]			;
		[ <lFontItalic : ITALIC> ]		;
		[ <lFontUnderline : UNDERLINE> ]	;
		[ <lFontStrikeout : STRIKEOUT> ]	;
		[ TOOLTIP <cToolTip> ]  		;
		[ BACKCOLOR <aBackColor> ]		;
		[ FONTCOLOR <aFontColor> ]		;
		[ DYNAMICBACKCOLOR <aDynamicBackColor> ];
		[ DYNAMICFORECOLOR <aDynamicForeColor> ];
		[ ON GOTFOCUS <bOnGotFocus> ] 		;
		[ ON CHANGE <bOnChange> ]  		;
		[ ON LOSTFOCUS <bOnLostFocus> ] 	;
		[ ON DBLCLICK <bOnDblClick> ]  		;
		[ ON HEADCLICK <aOnHeadClick> ] 	;
		[ <lAllowEdit : EDIT> ]			;
		[ COLUMNCONTROLS <aColumnControls> ]	;
		[ COLUMNVALID <aColumnValid> ]		;
		[ COLUMNWHEN <aColumnWhen> ]		;
		[ <lVirtual: VIRTUAL> ] 		;
		[ ITEMCOUNT <nItemCount> ]		;
		[ ON QUERYDATA <bOnQueryData> ] 	;
		[ <lMultiSelect: MULTISELECT> ]		;
		[ <lNoLines: NOLINES> ] 		;
		[ <lNoShowHeaders: NOHEADERS> ]		;
		[ IMAGE <aImage> ] 			;
		[ JUSTIFY <aColumnJustify> ] 		;
		[ HELPID <nHelpId> ] 			;
		[ <lBreak: BREAK> ] 			;                             
		[ HEADERIMAGES <aHeaderImages> ]	;
		[ <lCellNavigation: CELLNAVIGATION> ]	;                             
		[ ROWSOURCE <cRowSource> ]		;
		[ COLUMNFIELDS <aColumnFields> ]	;
		[ <lAllowAppend : ALLOWAPPEND> ]	;
		[ <lAllowDelete : ALLOWDELETE> ]	;
		[ DYNAMICDISPLAY <aDynamicDisplay> ]	;
		[ ON SAVE <bOnSave> ]  			;
		[ LOCKCOLUMNS <nLockColumns> ]		;
	=>;
	With Object <oObj> := Grid():New() ; :Name := <"oObj">  ;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:ColumnHeaders	:= <aColumnHeaders>	]	;;
		[:ColumnWidths	:= <aColumnWidths>	]	;;
		[:Items		:= <aItems>		]	;;
		[:Value		:= <xValue>		]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:BackColor	:= <aBackColor>		]	;; 
		[:FontColor	:= <aFontColor>		]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:OnDblClick	:= <{bOnDblClick}>	]	;;
		[:OnHeadeClick	:= <{aOnHeadClick}>	]	;;
		[:AllowEdit	:= <.lAllowEdit.>	]	;;
		[:ColumnControls:= <aColumnControls>	]	;;
		[:ColumnValid	:= <aColumnValid>	]	;;
		[:ColumnWhen	:= <aColumnWhen>	]	;;
		[:Virtual	:= <.lVirtual.>		]	;;
		[:ItemCount	:= <nItemCount>		]	;;
		[:OnQueryData	:= <bOnQueryData>	]	;;
		[:MultiSelect	:= <lMultiSelect>	]	;;
		[:Lines		:= !<.lNoLines.>	]	;;
		[:ShowHeaders	:= !<.lNoShowHeaders.>	]	;;
		[:Image		:= <aImage>		]	;;
		[:ColumnJustify	:= <aColumnJustify>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:Break		:= <.lBreak.>		]	;;
		[:HeaderImages	:= <aHeaderImages>	]	;;
		[:CellNavigation:= <.lCellNavigation.>	]	;;
		[:RowSource	:= <cRowSource>		]	;;
		[:ColumnFields	:= <aColumnFields>	]	;;
		[:AllowAppend	:= <.lAllowAppend.>	]	;;
		[:AllowDelete	:= <.lAllowDelete.>	]	;;
		[:DynamicDisplay:= <aDynamicDisplay>	]	;;
		[:OnSave	:= <{bOnSave}>		]	;;
		[:LockColumns	:= <nLockColumns>	]	;;
		[:DynamicBackColor	:= <aDynamicBackColor>	]	;;
		[:DynamicForeColor	:= <aDynamicForeColor>	]	;;
	End <oObj>

* Tab *************************************************************************

#command DEFINE TAB <oObj> ;
		[ <dummy1: OF, PARENT> <oParent> ] ;
		AT <nRow> , <nCol> ;
		WIDTH <nWidth> ;
		HEIGHT <nHeight> ;
		[ VALUE <nValue> ] ;
		[ FONT <cFontName> ] ;
		[ SIZE <nFontSize> ] ;
		[ <lFontBold : BOLD> ] ;
		[ <lFontItalic : ITALIC> ] ;
		[ <lFontUnderline : UNDERLINE> ] ;
		[ <lFontStrikeout : STRIKEOUT> ] ;
		[ TOOLTIP <cToolTip> ] ;
                [ <lButtons: BUTTONS> ]       ;
                [ <lFlat: FLAT> ]       ;
		[ ON CHANGE <bOnChange> ] ;
                [ <lNoTabStop: NOTABSTOP> ]       ;
                [ <lMultiLine: MULTILINE> ]       ;
	=>;
	With Object <oObj> := Tab():New() ; :Name := <"oObj"> 	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Value		:= <nValue>		]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:Flat		:= <.lFlat.>		]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;;
		[:MultiLine	:= <.lMultiLine.>	]	


#command DEFINE TAB <oObj> ;
		[ PARENT> <oParent> ] ;
		ROW <nRow> ;
		COL <nCol> ;
		WIDTH <nWidth> ;
		HEIGHT <nHeight> ;
		[ VALUE <nValue> ] ;
		[ FONTNAME <cFontName> ] ;
		[ FONTSIZE <nFontSize> ] ;
		[ FONTBOLD <lFontBold> ] ;
		[ FONTITALIC <lFontItalic> ] ;
		[ FONTUNDERLINE <lFontUnderline> ] ;
		[ FONTSTRIKEOUT <lFontStrikeout> ] ;
		[ TOOLTIP <cTooltip> ] ;
                [ BUTTONS <lButtons> ]       ;
                [ FLAT <lFlat> ]       ;
		[ ON CHANGE <bOnChange> ] ;
                [ TABSTOP <lTabStop> ]       ;
                [ MULTILINE <lMultiLine> ]       ;
	=>;
	With Object <oObj> := Tab():New() ; :Name := <"oObj"> 	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Value		:= <nValue>		]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cTooltip>		]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:Flat		:= <.lFlat.>		]	;;
		[:TabStop	:= <.lTabStop.>		]	;;
		[:MultiLine	:= <.lMultiLine.>	]	

#command PAGE <cCaption> [ IMAGE <cImage> ] ;
	=>;
	:NewPage( <cCaption> , <cImage> )

#command DEFINE PAGE <cCaption> [ IMAGE <cImage> ] ;
	=>;
	:NewPage( <cCaption> , <cImage> )

#command DEFINE TAB PAGE <cCaption> [ IMAGE <cImage> ] ;
	=>;
	:NewPage( <cCaption> , <cImage> )

#command END PAGE  ;
	=>;
	:EndPage()

#xcommand END TAB => End With

* ComboBox ********************************************************************

#xcommand @ <nRow>,<nCol> COMBOBOX <oObj>		;
		[ <dummy1: OF, PARENT> <oParent> ]	;
		[ WIDTH <nWidth> ]			;
		[ HEIGHT <nHeight> ]			;
		[ ITEMS <aItems> ]			; 
		[ ITEMSOURCE <aItemSource> ]		; 
		[ VALUE <xValue> ]			;
		[ VALUESOURCE <cValueSource> ]		;
		[ <lDisplayEdit : DISPLAYEDIT> ]	;		
		[ FONT <cFontName> ]			;
		[ SIZE <nFontSize> ]			;
		[ <lFontBold : BOLD> ]			;
		[ <lFontItalic : ITALIC> ]		;
		[ <lFontUnderline : UNDERLINE> ]	;
		[ <lFontStrikeout : STRIKEOUT> ]	;
		[ TOOLTIP <cToolTip> ]			;
		[ ON GOTFOCUS <bOnGotFocus> ]		;
		[ ON CHANGE <bOnChange> ]		;
		[ ON LOSTFOCUS <bOnLostFocus> ]		;
		[ ON ENTER <bOnEnter> ]			;
		[ ON DISPLAYCHANGE <bOnDisplayChange> ]	;
		[ <lNoTabStop : NOTABSTOP> ]		;
		[ HELPID <nHelpId> ]			;
		[ <lNoVisible : INVISIBLE> ]		;
		[ <lSort : SORT> ]			;
		[ IMAGE <aImage> ]			;
		[ DROPPEDWIDTH <nDroppedWidth> ]	;
		[ ON DROPDOWN <bOnDropDown> ]		;
		[ ON CLOSEUP <bOnCloseUp> ]		;
	=>;
	With Object <oObj> := ComboBox():New(<"oObj">) ; :Name := <"oObj"> ;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Items		:= <aItems>		]	;;
		[:ItemSource	:= <aItemSource>	]	;;
		[:Value		:= <xValue>		]	;;
		[:ValueSource	:= <cValueSource>	]	;;
		[:DisplayEdit	:= <.lDisplayEdit.>	]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:OnEnter	:= <{bOnEnter}>		]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;; 
		[:HelpId	:= <nHelpId>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:Sort		:= <.lSort.>		]	;;
		[:Image		:= <aImage>		]	;;
		[:DroppedWidth	:= <nDroppedWidth>	]	;;
		[:OnDropDown	:= <{bOnDropDown}>	]	;;
		[:OnCloseUp	:= <{bOnCloseUp}>	]	;;
		[:OnDisplayChange  := <{bOnDisplayChange}>]	;; 
	End <oObj>

* ListBox *********************************************************************

#command @ <nRow>,<nCol> LISTBOX <oObj> ;
		[ <dummy1: OF, PARENT> <oParent> ] ;
		[ WIDTH <nWidth> ] ;
		[ HEIGHT <nHeight> ] ;
		[ ITEMS <aItems> ] ;
		[ VALUE <xValue> ] ;
		[ FONT <cFontName> ] ;
		[ SIZE <nFontSize> ] ;
		[ <lFontBold : BOLD> ] ;
		[ <lFontItalic : ITALIC> ] ;
		[ <lFontUnderline : UNDERLINE> ] ;
		[ <lFontStrikeout : STRIKEOUT> ] ;
		[ TOOLTIP <cToolTip> ] ;
		[ BACKCOLOR <aBackColor> ] ;
		[ FONTCOLOR <aFontColor> ] ;
		[ ON GOTFOCUS <bOnGotFocus> ] ;
		[ ON CHANGE <bOnChange> ] ;
		[ ON LOSTFOCUS <bOnLostFocus> ] ;
		[ ON DBLCLICK <bOnDblClick> ] ;
		[ <lMultiSelect : MULTISELECT> ] ;
		[ HELPID <nHelpId> ] 		;
		[ <lNoVisible : INVISIBLE> ] ;
		[ <lNoTabStop : NOTABSTOP> ] ;
		[ <lSort : SORT> ] ;
		[ <lDragItems : DRAGITEMS> ] ;
	=>;
	With Object <oObj> := ListBox():New() ; :Name := <"oObj"> ;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Items		:= <aItems>		]	;;
		[:Value		:= <xValue>		]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:BackColor	:= <aBackColor>		]	;;
		[:FontColor	:= <aFontColor>		]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:OnDblClick	:= <{bOnDblClick}>	]	;;
		[:MultiSelect	:= <.lMultiSelect.>	]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;; 
		[:Sort		:= <.lSort.>		]	;;
		[:lDragItems	:= <.lDragItems.>	]	;;
	End <oObj>

* Menu ************************************************************************

	* Main Menu ...........................................................

	#xcommand DEFINE MAIN MENU <oObj> [ OF <oParent> ] [ NAME <cName> ]	;
	=>									;
	With Object <oObj> := MainMenu():New()					;;
		[:Parent	:= <oParent>	]				;;
		[:Name		:= <cName>	]				;;


	#xcommand DEFINE MAINMENU <oObj> [ OF <oParent> ] [ NAME <cName> ]	;
	=>									;
	With Object <oObj> := MainMenu():New()					;;
		[:Parent	:= <oParent>	]				;;
		[:Name		:= <cName>	]				;;


	#xcommand DEFINE MAINMENU <oObj> [ PARENT <oParent> ] [ NAME <cName> ]	;
	=>									;
	With Object <oObj> := MainMenu():New()					;;
		[:Parent	:= <oParent>	]				;;
		[:Name		:= <cName>	]				;;


	#xcommand DEFINE MAINMENU <oObj> [ OF <oParent> ] [ NAME <cName> ]	;
	=>									;
	With Object <oObj> := MainMenu():New()					;;
		[:Parent	:= <oParent>	]				;;
		[:Name		:= <cName>	]				;;


	#xcommand END MENU ;
	=> ;
	End With

	* Popup ...............................................................

	#xcommand POPUP <oObj> [ CAPTION ] [ <cCaption> ] [ NAME <cName> ]	; 
	=> ;
	With Object <oObj> := MenuPopup():New()					;;
		[:Caption	:= <cCaption>	]				;;
		[:Name		:= <cName>	]				;;


	#xcommand DEFINE POPUP <oObj> [ CAPTION ] <cCaption> [ NAME <cName> ]	;
	=> ;
	With Object <oObj> := MenuPopup():New()					;;
		[:Caption	:= <cCaption>	]				;;
		[:Name		:= <cName>	]				;;


	#xcommand DEFINE MENU POPUP <oObj> [ CAPTION ] <cCaption> [ NAME <cName> ];
	=> ;
	With Object <oObj> := MenuPopup():New()					;;
		[:Caption	:= <cCaption>	]				;;
		[:Name		:= <cName>	]				;;


	#xcommand END POPUP ;
	=> ;
	End With


	* MenuItem ............................................................

	#xcommand ITEM <oObj> [ CAPTION ] <cCaption> [ ACTION <bOnClick> ] [ NAME <cName> ] [ IMAGE <cImage> ] [ <lChecked : CHECKED> ] ;
	=> ;
	With Object <oObj> := MenuItem():New()					;;
		[:Caption	:= <cCaption>	]				;;
		[:OnClick	:= <{bOnClick}>	]				;;
		[:Name		:= <cName>	]				;;
		[:Image		:= <cImage>	]				;;
		[:Checked	:= <lChecked>	]				;;
	End With


	#xcommand MENUITEM <oObj> [ CAPTION ] <cCaption> [ ACTION <bOnClick> ] [ NAME <cName> ] [ IMAGE <cImage> ] [ <lChecked : CHECKED> ];
	=> ;
	With Object <oObj> := MenuItem():New()					;;
		[:Caption	:= <cCaption>	]				;;
		[:OnClick	:= <{bOnClick}>	]				;;
		[:Name		:= <cName>	]				;;
		[:Image		:= <cImage>	]				;;
		[:Checked	:= <lChecked>	]				;;
	End With


	#xcommand MENUITEM <oObj> [ CAPTION ] <cCaption> [ ONCLICK <bOnClick> ] [ NAME <cName> ] [ IMAGE <cImage> ] [ CHECKED <lChecked> ];
	=> ;
	With Object <oObj> := MenuItem():New()					;;
		[:Caption	:= <cCaption>	]				;;
		[:OnClick	:= <{bOnClick}>	]				;;
		[:Name		:= <cName>	]				;;
		[:Image		:= <cImage>	]				;;
		[:Checked	:= <lChecked>	]				;;
	End With


	* Separator ...........................................................

	#xcommand SEPARATOR ;
	=> ;
	With Object oSeparator := MenuItem():New()	;;
		[:Caption	:= '-'	]		;;
	End With


* ToolBar *********************************************************************

#xcommand  DEFINE TOOLBAR <oObj> ;
		[ NAME <cName> ]			;
		[ OF <oParent> ] ;
                [ BUTTONSIZE <nButtonWidth> , <nButtonHeight> ] ;
                [ IMAGESIZE <nImageWidth> , <nImageHeight> ] ;
		[ <lStrictWidth : STRICTWIDTH> ] ;		
		[ FONT <cFontName> ] ;			
		[ SIZE <nFontSize> ] ;			
		[ <lBold : BOLD> ] ;		
		[ <lItalic : ITALIC> ] ;		
		[ <lUnderline : UNDERLINE> ] ;	
		[ <lStrikeout : STRIKEOUT> ] ;	
		[ TOOLTIP <cToolTip> ] ;		
		[ <lFlat: FLAT> ] ;
		[ <lBottom: BOTTOM> ] ;
		[ <lRightText: RIGHTTEXT> ] ;
		[ <dummy1: GRIPPERTEXT, CAPTION> <cGripperText> ] ;
		[ <lBorder : BORDER> ] ;		
	        [ <lBreak: BREAK> ] ;                           
	=> ;
	With Object <oObj> := ToolBar():New()			;;
		[:Name		:= <cName>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:ButtonWidth	:= <nButtonWidth>	]	;;
		[:ButtonHeight	:= <nButtonHeight>	]	;;
		[:ImageWidth	:= <nImageWidth>	]	;;
		[:ImageHeight	:= <nImageHeight>	]	;;
		[:StrictWidth	:= <.lStrictWidth.>	]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lBold.>		]	;;
		[:FontItalic	:= <.lItalic.>		]	;;
		[:FontUnderline	:= <.lUnderline.>	]	;;
		[:FontStrikeout	:= <.lStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:Flat		:= <.lFlat.>		]	;;
		[:Bottom	:= <.lBottom.>		]	;;
		[:RightText	:= <.lRightText.>	]	;;
		[:GripperText	:= <cGripperText>	]	;;
		[:Border	:= <.lBorder.>		]	;;
		[:Break		:= <.lBreak.>		]	;;


#xcommand  DEFINE TOOLBAR [ <oObj> ] ;
		[ NAME <cName> ]			;
		[ PARENT <oParent> ] ;
                [ BUTTONWIDTH <nButtonWidth> ] [ BUTTONHEIGHT <nButtonHeight> ] ;
                [ IMAGEWIDTH <nImageWidth> ] [ IMAGEHEIGHT <nImageHeight> ] ;
		[ STRICTWIDTH <lStrictWidth> ] ;		
		[ FONTNAME <cFontName> ] ;			
		[ FONTSIZE <nFontSize> ] ;			
		[ FONTBOLD <lBold> ] ;		
		[ FONTITALIC <lItalic> ] ;		
		[ FONTUNDERLINE <lUnderline> ] ;	
		[ FONTSTRIKEOUT <lStrikeout> ] ;	
		[ TOOLTIP <cTooltip> ] ;		
		[ FLAT <lFlat> ] ;
		[ BOTTOM <lBottom> ] ;
		[ RIGHTTEXT <lRightText> ] ;
		[ GRIPPERTEXT <cGripperText> ] ;
		[ BORDER <lBorder> ] ;		
	        [ BREAK <lBreak> ] ;                           
      => ;
	With Object <oObj> := ToolBar():New()			;;
		[:Name		:= <cName>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:ButtonWidth	:= <nButtonWidth>	]	;;
		[:ButtonHeight	:= <nButtonHeight>	]	;;
		[:ImageWidth	:= <nImageWidth>	]	;;
		[:ImageHeight	:= <nImageHeight>	]	;;
		[:StrictWidth	:= <.lStrictWidth.>	]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lBold.>		]	;;
		[:FontItalic	:= <.lItalic.>		]	;;
		[:FontUnderline	:= <.lUnderline.>	]	;;
		[:FontStrikeout	:= <.lStrikeout.>	]	;;
		[:ToolTip	:= <cTooltip>		]	;;
		[:Flat		:= <.lFlat.>		]	;;
		[:Bottom	:= <.lBottom.>		]	;;
		[:RightText	:= <.lRightText.>	]	;;
		[:GripperText	:= <cGripperText>	]	;;
		[:Border	:= <.lBorder.>		]	;;
		[:Break		:= <.lBreak.>		]	;;

#xcommand BUTTON <oObj> ;
		[ NAME <cName> ] ;
		[ CAPTION <cCaption> ] ;
		[ PICTURE <cPicture> ] ;
		[ ACTION <bOnClick> ] ;
		[ TOOLTIP <cToolTip> ] ;
		[ <lSeparator: SEPARATOR> ] ;
	        [ <lAutoSize: AUTOSIZE> ] ;             
		[ <lDropDown: DROPDOWN> ] ;
		[ <lWholeDropDown: WHOLEDROPDOWN> ] ;
		[ <lCheck: CHECK> ] ;
		[ <lGroup: GROUP> ] ;
	=>;
	With Object <oObj> := ToolButton():New()		;;
		[:Name		:= <cName>		]	;;
		[:Caption	:= <cCaption>		]	;;
		[:Picture	:= <cPicture>		]	;;
		[:OnClick	:= <bOnClick>		]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:Separator	:= <.lSeparator.>	]	;;
		[:AutoSize	:= <.lAutoSize.>	]	;;
		[:Style		:= if ( <.lDropDown.> , TBB_DROPDOWN  , if ( <.lWholeDropDown.> , TBB_WHOLEDROPDOWN ,  if ( <.lCheck.> .and. <.lGroup.> , TBB_CHECKGROUP , if ( <.lCheck.> .and. !<.lGroup.> , TBB_CHECK , TBB_STANDARD ) ) ) ) ] ;;
	End <oObj>


#xcommand TOOLBUTTON <oObj> ;
		[ NAME <cName> ] ;
		[ CAPTION <cCaption> ] ;
		[ PICTURE <cPicture> ] ;
		[ ONCLICK <bOnClick> ] ;
		[ TOOLTIP <cToolTip> ] ;
		[ SEPARATOR <lSeparator> ] ;
	        [ AUTOSIZE <lAutoSize> ] ;             
		[ DROPDOWN <lDropDown> ] ;
		[ WHOLEDROPDOWN <lWholeDropDown> ] ;
		[ CHECK <lCheck> ] ;
		[ GROUP <lGroup> ] ;
	=>;
	With Object <oObj> := ToolButton():New()		;;
		[:Name		:= <cName>		]	;;
		[:Caption	:= <cCaption>		]	;;
		[:Picture	:= <cPicture>		]	;;
		[:OnClick	:= <{bOnClick}>		]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:Separator	:= <.lSeparator.>	]	;;
		[:AutoSize	:= <.lAutoSize.>	]	;;
		[:Style		:= if ( <.lDropDown.> , TBB_DROPDOWN  , if ( <.lWholeDropDown.> , TBB_WHOLEDROPDOWN ,  if ( <.lCheck.> .and. <.lGroup.> , TBB_CHECKGROUP , if ( <.lCheck.> .and. !<.lGroup.> , TBB_CHECK , TBB_STANDARD ) ) ) ) ] ;;
	End <oObj>


#xcommand TOOLBUTTON <oObj> ;
		[ NAME <cName> ] ;
		[ CAPTION <cCaption> ] ;
		[ PICTURE <cPicture> ] ;
		[ ONCLICK <bOnClick> ] ;
		[ TOOLTIP <cToolTip> ] ;
		[ SEPARATOR <lSeparator> ] ;
	        [ AUTOSIZE <lAutoSize> ] ;             
	        STYLE <nStyle> ;             
	=>;
	With Object <oObj> := ToolButton():New()		;;
		[:Name		:= <cName>		]	;;
		[:Caption	:= <cCaption>		]	;;
		[:Picture	:= <cPicture>		]	;;
		[:OnClick	:= <{bOnClick}>		]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:Separator	:= <.lSeparator.>	]	;;
		[:AutoSize	:= <.lAutoSize.>	]	;;
		[:Style		:= <nStyle>		]	;;
	End <oObj>

#xcommand  END TOOLBAR => End With

* DatePicker ******************************************************************

#command @ <nRow>,<nCol> DATEPICKER <oObj> ;
		[ NAME <cName> ] ;
		[ <dummy1: OF, PARENT> <oParent> ] ;
		[ VALUE <dValue> ] ;
		[ FIELD <cField> ] ;
		[ WIDTH <nWidth> ] ;
		[ HEIGHT <nHeight> ] ;
		[ FONT <cFontName> ] ;
		[ SIZE <nFontSize> ] ;
		[ <lFontBold : BOLD> ] ;
		[ <lFontItalic : ITALIC> ] ;
		[ <lFontUnderline : UNDERLINE> ] ;
		[ <lFontStrikeout : STRIKEOUT> ] ;
		[ TOOLTIP <cToolTip> ] ;
		[ < lShownone: SHOWNONE > ] ;
		[ < lUpdown: UPDOWN > ] ;
		[ < lRightalign: RIGHTALIGN > ] ;
		[ ON GOTFOCUS <bOnGotFocus> ] ;
		[ ON CHANGE <bOnChange> ] ;
		[ ON LOSTFOCUS <bOnLostFocus> ] ;
                [ ON ENTER <bOnEnter> ]		;
		[ HELPID <nHelpId> ] 		;
		[ <lNoVisible: INVISIBLE> ] ;
		[ <lNoTabStop: NOTABSTOP> ] ;
	=>;
	With Object <oObj> := DatePicker():New() ; :Name := <"oObj"> ;;
		[:Parent	:= <oParent>		]	;;
		[:Name		:= <cName>		]	;;
		[:Value		:= <dValue>		]	;;
		[:Field		:= <cField>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:FontName	:= <cFontName>		]	;;
		[:FontSize	:= <nFontSize>		]	;;
		[:FontBold	:= <.lFontBold.>	]	;;
		[:FontItalic	:= <.lFontItalic.>	]	;;
		[:FontUnderline	:= <.lFontUnderline.>	]	;;
		[:FontStrikeout	:= <.lFontStrikeout.>	]	;;
		[:ToolTip	:= <cToolTip>		]	;;
		[:ShowNone	:= <.lShownone.>	]	;;
		[:UpDown	:= <.lUpdown.>		]	;;
		[:Alignment	:= if ( <.lRightalign.> , DTP_RIGHT , DTP_LEFT ) ]	;;
		[:OnGotFocus	:= <{bOnGotFocus}>	]	;;
		[:OnChange	:= <{bOnChange}>	]	;;
		[:OnLostFocus	:= <{bOnLostFocus}>	]	;;
		[:OnEnter	:= <{bOnEnter}>		]	;;
		[:HelpId	:= <nHelpId>		]	;;
		[:Visible	:= !<.lNoVisible.>	]	;;
		[:TabStop	:= !<.lNoTabStop.>	]	;;
	End <oObj>

* Progressbar ***********************************************************************

#command @ <nRow>,<nCol> PROGRESSBAR <oObj>   ;
		[ NAME <cName> ] ;
		[ <dummy1: OF, PARENT> <oParent> ] ;
		[ WIDTH <nWidth> ]   ;
		[ HEIGHT <nHeight> ]   ;
		[ RANGE <nRangeMin> , <nRangeMax> ] ;
   	    [ VALUE <uValue> ] ;
	=>;
	With Object <oObj> := Progressbar():New() ; :Name := <"oObj"> ;;
		[:Name		:= <cName>		]	;;
		[:Parent	:= <oParent>		]	;;
		[:Row		:= <nRow>		]	;;
		[:Col		:= <nCol>		]	;;
		[:Width		:= <nWidth>		]	;;
		[:Height	:= <nHeight>		]	;;
		[:Range  	:= <nRangeMin> , <nRangeMax>	]	;;
		[:Value  	:= <uValue>	]	;;
    End <oObj>
	
	
	

* Alternate Syntax ************************************************************

#xcommand DEFINE WINDOW <oObj> ;
=>;
	__MVPUBLIC ( <"oObj"> )						;;
	With Object <oObj> := Window():New()				;;

#xcommand DEFINE DATEPICKER <oObj> => With Object <oObj> := DatePicker():New(<"oObj">) ; :Name := <"oObj">
#xcommand END DATEPICKER => End

#xcommand DEFINE FRAME <oObj> => With Object <oObj> := Frame():New(<"oObj">) ; :Name := <"oObj">
#xcommand END FRAME => End

#xcommand DEFINE BUTTON <oObj> => With Object <oObj> := Button():New(<"oObj">) ; :Name := <"oObj">
#xcommand END BUTTON => End

#xcommand DEFINE LABEL <oObj> => With Object <oObj> := Label():New(<"oObj">) ; :Name := <"oObj">
#xcommand END LABEL => End

#xcommand DEFINE CHECKBOX <oObj> => With Object <oObj> := CheckBox():New( <"oObj"> ) ; :Name := <"oObj">
#xcommand END CHECKBOX => End

#xcommand DEFINE TEXTBOX <oObj> => With Object <oObj> := TextBox():New(<"oObj">) ; :Name := <"oObj">
#xcommand END TEXTBOX => End

#xcommand DEFINE EDITBOX <oObj> => With Object <oObj> := EditBox():New(<"oObj">) ; :Name := <"oObj">
#xcommand END EDITBOX => End

#xcommand DEFINE SPINNER <oObj> => With Object <oObj> := Spinner():New(<"oObj">) ; :Name := <"oObj">
#xcommand END SPINNER => End

#xcommand DEFINE GRID <oObj> => With Object <oObj> := Grid():New(<"oObj">) ; :Name := <"oObj">
#xcommand END GRID => End

#xcommand DEFINE COMBOBOX <oObj> => With Object <oObj> := ComboBox():New(<"oObj">) ; :Name := <"oObj">
#xcommand END COMBOBOX => End

#xcommand DEFINE LISTBOX <oObj> => With Object <oObj> := ListBox():New(<"oObj">) ; :Name := <"oObj">
#xcommand END LISTBOX => End

#xcommand DEFINE PROGRESSBAR <oObj> => With Object <oObj> := Progressbar():New(<"oObj">) ; :Name := <"oObj">
#xcommand END PROGRESSBAR => End


#xcommand NAME			<value>	=>	:Name		:= <value>
#xcommand ROW			<value>	=>	:Row		:= <value>
#xcommand COL			<value>	=>	:Col		:= <value>
#xcommand PARENT		<value>	=>	:Parent		:= <value>
#xcommand CAPTION		<value>	=>	:Caption	:= <value>
#xcommand WIDTH			<value>	=>	:Width		:= <value>
#xcommand HEIGHT		<value>	=>	:Height		:= <value>
#xcommand FONT			<value>	=>	:FontName	:= <value>
#xcommand SIZE			<value>	=>	:FontSize	:= <value>
#xcommand BOLD			<value>	=>	:FontBold	:= <value>
#xcommand ITALIC		<value>	=>	:FontItalic	:= <value>
#xcommand UNDERLINE		<value>	=>	:FontUnderLine	:= <value>
#xcommand STRIKEOUT		<value>	=>	:FontStrikeOut	:= <value>
#xcommand BACKCOLOR		<value>	=>	:BackColor	:= <value>
#xcommand FONTCOLOR		<value>	=>	:FontColor	:= <value>
#xcommand TRANSPARENT		<value>	=>	:Transparent	:= <value>
#xcommand MULTILINE		<value>	=>	:Multiline	:= <value>
#xcommand PICTURE		<value>	=>	:Picture	:= <value>
#xcommand TOOLTIP		<value>	=>	:ToolTip	:= <value>
#xcommand ONCLICK		<value>	=>	:OnClick	:= <{value}>
#xcommand PICTALIGNMENT		<value>	=>	:PictAlignment	:= <value>
#xcommand VALUE			<value>	=>	:Value		:= <value>
#xcommand ALIGNMENT		<value>	=>	:Alignment	:= <value>
#xcommand VISIBLE		<value>	=>	:Visible	:= <value>
#xcommand FIELD			<value>	=>	:Field		:= <value>
#xcommand TABSTOP		<value>	=>	:TabStop	:= <value>
#xcommand ONCHANGE		<value>	=>	:OnChange	:= <{value}>
#xcommand MaxLength		<value>	=>	:MaxLength	:= <value>
#xcommand CaseConvert		<value>	=>	:CaseConvert	:= <value>
#xcommand DataType		<value>	=>	:CaseConvert 	:= <value>
#xcommand PassWord		<value>	=>	:PassWord 	:= <value>
#xcommand InputMask		<value>	=>	:InputMask	:= <value>
#xcommand Format		<value>	=>	:Format		:= <value>
#xcommand OnEnter		<value>	=>	:OnEnter	:= <{value}>
#xcommand ReadOnly		<value>	=>	:ReadOnly	:= <value>
#xcommand Alignment		<value>	=>	:Alignment	:= <value>
#xcommand RangeMax		<value>	=>	:RangeMax	:= <value>
#xcommand RangeMin		<value>	=>	:RangeMin	:= <value>
#xcommand Wrap			<value>	=>	:Wrap		:= <value>
#xcommand Increment		<value>	=>	:Increment	:= <value>
#xcommand AllowAppend		<value>	=>	:AllowAppend	:= <value>
#xcommand AllowDelete		<value>	=>	:AllowDelete	:= <value>
#xcommand AllowEdit		<value>	=>	:AllowEdit	:= <value>
#xcommand CellNavigation	<value>	=>	:CellNavigation	:= <value>
#xcommand ColumnControls	<value>	=>	:ColumnControls	:= <value>
#xcommand ColumnFields		<value>	=>	:ColumnFields	:= <value>
#xcommand ColumnValid		<value>	=>	:ColumnValid	:= <value>
#xcommand ColumnWhen		<value>	=>	:ColumnWhen	:= <value>
#xcommand ColumnWidths		<value>	=>	:ColumnWidths	:= <value>
#xcommand ColumnHeaders		<value>	=>	:ColumnHeaders	:= <value>
#xcommand DynamicDisplay	<value>	=>	:DynamicDisplay	:= <value>
#xcommand HeaderImages		<value>	=>	:HeaderImages	:= <value>
#xcommand Image			<value>	=>	:Image		:= <value>
#xcommand ItemCount		<value>	=>	:ItemCount	:= <value>
#xcommand Items			<value>	=>	:Items		:= <value>
#xcommand ColumnJustify		<value>	=>	:ColumnJustify	:= <value>
#xcommand Lines			<value>	=>	:Lines		:= <value>
#xcommand LockColumns		<value>	=>	:LockColumns	:= <value>
#xcommand MultiSelect		<value>	=>	:MultiSelect	:= <value>
#xcommand RowSource		<value>	=>	:RowSource	:= <value>
#xcommand ShowHeaders		<value>	=>	:ShowHeaders	:= <value>
#xcommand Virtual		<value>	=>	:Virtual	:= <value>
#xcommand RecNo			<value>	=>	:RecNo		:= <value>
#xcommand Cell			<value>	=>	:Cell		:= <value>
#xcommand Item			<value>	=>	:Item		:= <value>
#xcommand Header		<value>	=>	:Header		:= <value>
#xcommand Break			<value>	=>	:Break		:= <value>
#xcommand Item 			<value>	=>	:Item		:= <value>
#xcommand DisplayValue		<value>	=>	:DisplayValue	:= <value>
#xcommand ItemSource		<value>	=>	:ItemSource	:= <value>
#xcommand Sort			<value>	=>	:Sort		:= <value>
#xcommand DroppedWidth		<value>	=>	:DroppedWidth	:= <value>
#xcommand DisplayEdit		<value>	=>	:DisplayEdit	:= <value>
#xcommand ValueSource		<value>	=>	:ValueSource	:= <value>
#xcommand OnDropDown    	<value>	=>	:OnDropDown	:= <{value}>
#xcommand OnCloseUp		<value>	=>	:OnCloseUp	:= <{value}>
#xcommand OnDisplayChange       <value>	=>	:OnDisplayChange:= <{value}>
#xcommand DragItems		<value>	=>	:DragItems	:= <value>	
#xcommand ShowNone		<value>	=>	:ShowNone	:= <value>
#xcommand UpDown		<value>	=>	:UpDown		:= <value>
#xcommand DynamicBackColor	<value>	=>	:DynamicBackColor	:= <value>
#xcommand DynamicForeColor	<value>	=>	:DynamicForeColor	:= <value>
#xcommand DisabledBackColor	<value>	=>	:DisabledBackColor	:= <value>
#xcommand DisabledFontColor	<value>	=>	:DisabledFontColor	:= <value>
#xcommand TYPE			<value>	=>	:Type			:= <value>
#xcommand TITLE			<value>	=>	:Title			:= <value>
#xcommand ONINIT		<value>	=>	:OnInit			:= <{value}>
#xcommand VIRTUALWIDTH		<value>	=>	:VirtualWidth		:= <value>
#xcommand VIRTUALHEIGHT		<value>	=>	:VirtualHeight		:= <value>
#xcommand ICON			<value>	=>	:Icon			:= <value>
#xcommand CURSOR		<value>	=>	:Cursor			:= <value>
#xcommand ONRELEASE		<value>	=>	:OnRelease		:= <{value}>
#xcommand ONINTERACTIVECLOSE	<value>	=>	:OnInteractiveClose	:= <{value}>
#xcommand ONMOUSECLICK		<value>	=>	:OnMouseClick		:= <{value}>
#xcommand ONMOUSEDRAG		<value>	=>	:OnMouseDrag		:= <{value}>
#xcommand ONMOUSEMOVE		<value>	=>	:OnMouseMove		:= <{value}>
#xcommand ONSIZE		<value>	=>	:OnSize			:= <{value}>
#xcommand ONMAXIMIZE		<value>	=>	:OnMaximize		:= <{value}>
#xcommand ONMINIMIZE		<value>	=>	:OnMinimize		:= <{value}>
#xcommand ONPAINT		<value>	=>	:OnPaint		:= <{value}>
#xcommand NOTIFYICON		<value>	=>	:NotifyIcon		:= <value>
#xcommand NOTIFYTOOLTIP		<value>	=>	:NotifyToolTip		:= <value>
#xcommand ONNOTIFYCLICK		<value>	=>	:OnNotifyClick		:= <{value}>
#xcommand ONGOTFOCUS		<value>	=>	:OnGotFocus		:= <{value}>
#xcommand ONLOSTFOCUS		<value>	=>	:OnLostFocus		:= <{value}>
#xcommand ONSCROLLUP		<value>	=>	:OnScrollUp		:= <{value}>
#xcommand ONSCROLLDOWN		<value>	=>	:OnScrollDown		:= <{value}>
#xcommand ONSCROLLLEFT		<value>	=>	:OnScrollLeft		:= <{value}>
#xcommand ONSCROLLRIGHT		<value>	=>	:OnScrollRight		:= <{value}>
#xcommand ONHSCROLLBOX		<value>	=>	:OnHScrollBox		:= <{value}>
#xcommand ONVSCROLLBOX		<value>	=>	:OnVScrollBox		:= <{value}>
#xcommand HELPBUTTON		<value>	=>	:HelpButton		:= <value>
#xcommand VISIBLE		<value>	=>	:Visible		:= <value>
#xcommand AUTORELEASE 		<value>	=>	:AutoRelease		:= <value>
#xcommand MINBUTTON		<value>	=>	:MinButton		:= <value>
#xcommand MAXBUTTON		<value>	=>	:MaxButton		:= <value>
#xcommand SIZABLE		<value>	=>	:Sizable		:= <value>
#xcommand SYSMENU		<value>	=>	:SysMenu		:= <value>
#xcommand TITLEBAR		<value>	=>	:TitleBar		:= <value>
#xcommand TOPMOST		<value>	=>	:TopMost		:= <value>
#xcommand MaxButton		<value>	=>	:MaxButton		:= <value>
#xcommand MinButton		<value>	=>	:MinButton		:= <value>
#xcommand Sizable		<value>	=>	:Sizable		:= <value>
#xcommand Sysmenu		<value>	=>	:SysMenu		:= <value>
#xcommand ScrollBars		<value>  =>	:ScrollBars		:= <value>
